package NTLSystem.support;

import java.beans.*;
import sun.beans.editors.*;

/**
 * An editor for use with the PropertyCollectionSheetPanel which
 * uses Fmt.getDbl( String ) to support exponential notation for
 * Double values.
 * <P>
 * This class should be registered with the PropertyEditorManager in
 * order to be useful.
 * <P>
 * $Id: DoubleEditor.java,v 1.1 1998/08/08 02:02:49 jsled Exp $
 * Last Editor: $Author: jsled $
 *
 * @author    Joshua Sled [jsled@icsi.berkeley.edu]
 * @see       PropertyCollectionSheetPanel
 * @see       java.beans.PropertyEditorManager
 * @version   $Revision: 1.1 $
 **/
public class DoubleEditor
    extends NumberEditor
{
    public void setAsText(String text)
	throws IllegalArgumentException
    {
	setValue( new Double(Fmt.getDbl( text )) );
    }

}
