package NTLSystem.support;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

/**
 * Support for PropertyEditors that use tags.
 * <P>
 * Stolen from the BDK.  Re-written to use Swing 1.0.2.
 * <P>
 * $Id: PropertySelector.java,v 1.4 1998/08/08 02:02:55 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 *
 * @version $Revision: 1.4 $
 **/
class PropertySelector
extends JComboBox
implements ItemListener {

  PropertySelector(PropertyEditor pe) {
    super(pe.getTags());
    setEditable(false);
    editor = pe;
    setSelectedIndex(0);
    // This is a noop if the getAsText is not a tag.
    setSelectedItem( editor.getAsText() );
    addItemListener(this);
  }

  public void itemStateChanged(ItemEvent evt) {
    String s = (String)getSelectedItem();
    editor.setAsText( s );
  }
  
  public void repaint() {
      //setSelectedItem( editor.getAsText() );
      super.repaint();
  }
  
  PropertyEditor editor;    
}
