package NTLSystem;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import NTLSystem.support.*;

///////////////////////////////////////////////////////////////////////
// A set of pointers to Scenarios for training, recognition testing,
// and obeying.

class Dataset implements Serializable {

  private String id;

  private Vector train, recognize, obey;  // Vector<String>

  Dataset(NestedStreamTokenizer input, String newId) {
    id = newId;
    train = new Vector();
    recognize = new Vector();
    obey = new Vector();
    try {
      int token = input.nextToken();
      while (token != NestedStreamTokenizer.TT_EOF) {
	if (token != NestedStreamTokenizer.TT_WORD ||
	    (!input.sval.equals("train") && 
	     !input.sval.equals("recognize") &&
	     !input.sval.equals("obey"))) {
	  throw(new IOException("expected train/recognize/obey"));
	}
	Vector v = null;
	if (input.sval.equals("train")) v = train;
	else if (input.sval.equals("recognize")) v = recognize;
	else if (input.sval.equals("obey")) v = obey;
	token = input.nextToken();
	if (token != NestedStreamTokenizer.TT_NESTED) {
	  throw(new IOException("expected nested list of scenarios"));
	}
	NestedStreamTokenizer list = new 
	  NestedStreamTokenizer(new StringReader(input.sval));
	token = list.nextToken();
	while (token != NestedStreamTokenizer.TT_EOF) {
	  if (token != NestedStreamTokenizer.TT_WORD) {
    //	      !VerbLearn.context().scenarios().containsKey(list.sval)) {
	    throw(new IOException("invalid scenario name:"));
	  }
	  v.addElement(list.sval);
	  token = list.nextToken();
	}
	token = input.nextToken();
      }
    }
    catch (IOException e) {
      System.err.println("Dataset load-from-file exception: " + 
			 e.getMessage());
      train = new Vector();
      recognize = new Vector();
      obey = new Vector();
    }
  }

  public String id() { return id; }

  public void setId(String newId) { id = newId; }

  public Enumeration trainEnum() { return train.elements(); }

  public Enumeration recognizeEnum() { return recognize.elements(); }

  public Enumeration obeyEnum() { return obey.elements(); }

  public String toString() {
    StringBuffer res = new StringBuffer();
    res.append("// Dataset: ").append(id).append("\n\ntrain {");
    for (int i = 0; i < train.size(); i++) {
      res.append("\n\t").append(train.elementAt(i));
    }
    res.append("\n}\nrecognize {");
    for (int i = 0; i < recognize.size(); i++) {
      res.append("\n\t").append(recognize.elementAt(i));
    }
    res.append("\n}\nobey {");
    for (int i = 0; i < obey.size(); i++) {
      res.append("\n\t").append(obey.elementAt(i));
    }
    res.append("\n}\n");
    return res.toString();
  }
}
