package NTLSystem;

import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import NTLSystem.support.*;

/**
 * A CandidateMerge is a simple tuple of two senses and the similarity
 * between them.  It exists so that merges can be easily un-done, if
 * necessary [necessary being: if a merge lowers the Lexicon's
 * posterior].
 * <P>
 * $Id: CandidateMerge.java,v 1.1 1998/07/31 21:11:24 jsled Exp $<BR>
 * Last editor: $Author: jsled $
 * 
 * @author    David Bailey [dbailey@icsi.berkeley.edu]
 * @see       Sense
 * @version   $Revision: 1.1 $
 **/
class CandidateMerge
    implements Serializable
{
  
    public Sense s1, s2;
    public double similarity;

    /**
     * The no-arg constructor for Serialization.
     **/
    CandidateMerge() {}

    /**
     * Creates the tuple.
     **/
    CandidateMerge(Sense s1, Sense s2, double similarity)
    {
	this.s1 = s1;
	this.s2 = s2;
	this.similarity = similarity;
    }

    /**
     * Redefinition of Object.toString()
     **/
    public String toString()
    {
	return "senses " + s1.id() + " and " + s2.id() + " (similarity = " +
    similarity + ")";
    }
}
