package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// DoubleEnumeration basically composes two Enumerations into one.

class DoubleEnumeration implements Enumeration {

  private boolean aIsDone;
  private Enumeration a, b;

  DoubleEnumeration(Enumeration a, Enumeration b) {
    this.a = a;
    this.b = b;
    aIsDone = !a.hasMoreElements();
  }

  public boolean hasMoreElements() {
    if (!aIsDone) {
      return a.hasMoreElements();
    }
    else {
      return b.hasMoreElements();
    }
  }

  public Object nextElement() {
    if (!aIsDone) {
      Object o = a.nextElement();
      aIsDone = !a.hasMoreElements();
      return o;
    }
    else {
      return b.nextElement();
    }
  }
}

