package NTLSystem.verblearn;

import java.io.*;
import java.util.*;
import com.sun.java.swing.*;
import java.awt.*;
import java.awt.event.*;
import NTLSystem.support.*;


///////////////////////////////////////////////////////////////////////
// Choice box for choosing a dataset file.

class DatasetChoice extends Panel implements Observer {

  private Choice choice;
  private String currentLangslot;

  DatasetChoice() {
    add(new Label("Pick a dataset file:"));
    VerbLearn.context().addObserver(this);
    update(VerbLearn.context(), null);
  }

  public boolean action(Event e, Object arg) {
    if (arg.equals("None yet")) VerbLearn.context().setDataset((String)null);
    else VerbLearn.context().setDataset((String)arg);
    return true;
  }

  public void update(Observable o, Object junk) {
    Context c = (Context)o;
    rebuild();
    String sel;
    if (c.dataset() != null) sel = c.dataset().id();
    else sel = "None yet";
    choice.select(sel);
  }

  private void rebuild() {
    if (choice != null) {
      remove(choice);
    }
    choice = new Choice();
    choice.addItem("None yet");
    for (int i = 0; i < VerbLearn.context().datasetList().length; i++) {
      choice.addItem(VerbLearn.context().datasetList()[i]);
    }
    add(choice);
    // validate();  // refreshes panel -- got idea from netnews
  }
}
