# Generic Makefile for the NTLSystem project.
# This will work recursively into all directories.
#
# Specify the SUBDIRS, SOURCES and CLASSDIR variables to get it to
# work.
#
# Author: Josh Sled [jsled@icsi.berkeley.edu]
# $Id: java.makefile,v 1.2 1998/08/06 02:41:27 jsled Exp $
#

# List of subdirectories.
#
# NOTE: If you add a subdirectory, all you need to do [and it is
# required] is add it's name to this var. The makefile will take care
# of the rest.
SUBDIRS=

# List of sources.
#
# NOTE: If you add a source file, all you need to do [and it is
# required] is to add it's name to this variable.  The makefile will
# take care of the rest.
SOURCES=

# Location of .class files relative to this directory.
CLASSDIR=../../classes

# Export the variables down the make hierarchy.
.EXPORT_ALL_VARIABLES:

# RULES

# target 'all' is the subdirectories and the classes.
# If there are no sources, then don't try and compile them as it will
# cause an error.  The way the directories are set up, this is not a
# problem.
.PHONY: all
ifneq ($(SOURCES),)
all: dirs classes
else
all: dirs
endif

# take care of the directories.
.PHONY: dirs
dirs: $(SUBDIRS)

.PHONY: $(SUBDIRS)
$(SUBDIRS):
	cd $@; $(MAKE) -$(MAKEFLAGS)

# take care of the classes.
.PHONY: classes
classes: 
	$(JAVAC) $(JAVAC_OPTS) -d $(CLASSDIR) $(SOURCES)

# rule to compile any single given class file
%.class: %.java
	$(JAVAC) $(JAVAC_OPTS) -d $(CLASSDIR) $<
